import { AbstractControl } from '@angular/forms';
import { FormDefinitionAny, FormDefinitionCustomField, FormDefinitionField, FormDefinitionGroup, FormDefinitionGroupArray, FormDefinitionPrimitiveArray, NativeFormControlInfer, PrimitiveType, TypedFormControlInfer } from '../model';
import { TypedFormArray, TypedFormControl, TypedFormGroup } from './typed-form-control';
export declare function createForm<T extends PrimitiveType>(initialValue: T | FormDefinitionField<T>): TypedFormControl<T>;
export declare function createForm<T extends PrimitiveType[]>(initialValue: T | FormDefinitionPrimitiveArray<T[0]>): TypedFormArray<T[0]>;
export declare function createForm<T>(formDefinition: FormDefinitionGroupArray<T>): TypedFormArray<T>;
export declare function createForm<T>(formDefinition: FormDefinitionGroup<T>): TypedFormGroup<T>;
export declare function createForm<T>(formDefinitionOrInitialValue: FormDefinitionAny<T> | PrimitiveType | PrimitiveType[]): TypedFormControlInfer<any>;
export declare function createNativeForm<T extends PrimitiveType>(initialValue: T | FormDefinitionField<T>): NativeFormControlInfer<T>;
export declare function createNativeForm<T extends PrimitiveType[]>(initialValue: T | FormDefinitionPrimitiveArray<T[0]>): NativeFormControlInfer<T>;
export declare function createNativeForm<T>(formDefinition: FormDefinitionGroupArray<T>): NativeFormControlInfer<T[]>;
export declare function createNativeForm<T extends {
    [k: string]: any;
}>(formDefinition: FormDefinitionGroup<T>): NativeFormControlInfer<T>;
export declare function createNativeForm<T>(formDefinitionOrInitialValue: FormDefinitionAny<T> | PrimitiveType | PrimitiveType[]): AbstractControl<any>;
export declare function pushFormGroupArrayItem<F>(formArrayDefinition: FormDefinitionGroupArray<F> | FormDefinitionCustomField<F[]>, formArray: TypedFormArray<F>, value?: F, options?: {
    emitEvent?: boolean;
}): TypedFormArray<F>;
