import { Observable } from 'rxjs';
import { FormDefinitionAny, FormRegistryKey, InitialFormData, TypedFormControlInfer, TypedFormRegistryKey } from '../model';
import * as i0 from "@angular/core";
export interface FormRegistryEntry<T> {
    form: TypedFormControlInfer<T>;
    formDefinition?: FormDefinitionAny<T>;
}
export interface FormCreationOptions<T> {
    key?: FormRegistryKey<T>;
    initialData?: InitialFormData<T>;
}
export declare class FormRegistry {
    private forms;
    createOrNormalizeFormKey<T>(key?: FormRegistryKey<T>): TypedFormRegistryKey<T>;
    createAndRegisterForm<T>(formDefinition: FormDefinitionAny<T>, options?: FormCreationOptions<T>): FormRegistryKey<T>;
    registerForm<T>(form: TypedFormControlInfer<T>, key?: FormRegistryKey<T>): FormRegistryKey<T>;
    getForm<T>(key: FormRegistryKey<T>): TypedFormControlInfer<T> | null;
    removeForm(key: FormRegistryKey<any>): boolean;
    clearForms(): void;
    containsForm(key: FormRegistryKey<any>): boolean;
    observeForm<T>(key: FormRegistryKey<T>): Observable<T> | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormRegistry, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FormRegistry>;
}
