import { ChangeDetectorRef, PipeTransform } from '@angular/core';
import { FormRegistryKey, TypedFormControlInfer } from '../model';
import { FormRegistry } from './form-registry.service';
import * as i0 from "@angular/core";
export declare type ObserveFormType = 'FormControl' | 'FormValue';
export interface ObserveFormPipeOptions {
    readonly observe?: ObserveFormType;
    readonly strict?: boolean;
}
export declare class ObserveFormPipe implements PipeTransform {
    private formRegistry;
    private cdr;
    private latestObservedValue;
    private latestReturnedValue;
    private latestObservable?;
    private subscription?;
    transform<F>(formKey: FormRegistryKey<F>, options: {
        observe: 'FormValue';
        strict: false;
    }): F | null;
    transform<F>(formKey: FormRegistryKey<F>, options: {
        observe?: 'FormControl';
        strict: false;
    }): TypedFormControlInfer<F> | null;
    transform<F>(formKey: FormRegistryKey<F>, options: {
        observe: 'FormValue';
        strict?: true;
    }): F;
    transform<F>(formKey: FormRegistryKey<F>, options?: {
        observe?: 'FormControl';
        strict?: true;
    }): TypedFormControlInfer<F>;
    private handleSubscription;
    constructor(formRegistry: FormRegistry, cdr: ChangeDetectorRef);
    static ɵfac: i0.ɵɵFactoryDeclaration<ObserveFormPipe, never>;
    static ɵpipe: i0.ɵɵPipeDeclaration<ObserveFormPipe, "observeForm", false>;
}
